;% Two possibilities for the core are given - quadratic or cubic. The
;% former has a discontinuity in the second radial derivative of the
;% vorticity at the rmw, which makes w discontinuous there. The latter
;% is ok there. 

rm = 4e4;   % radius of max winds
vm = 40.0;  % max gradient wind speed
b = 1.3;    % Holland (1980) b parameter
lat = 15;   % latitude
rho = 1.1;  % air density
dp = vm^2 * rho * 2.71828 / b;  % environment-centre pressure difference.
pe = 1e5;   % Environment pressure
f = 2*7.292e-5*sin(lat*!pi/180);  % Coriolis parameter
Ut = -5;    % Translation speed

ds = 5e3;   % Grid spacing
lp = 30;    % Grid size is 2*lp + 1 square
;%problem with syntax meshgrid
;%[x,y] = meshgrid( [-lp:lp]*ds, [-lp:lp]*ds );
x=fltarr(2*lp+1,2*lp+1) & y=fltarr(2*lp+1,2*lp+1)
for i=0,2*lp do for j=0,2*lp do x(j,i)=-lp*ds+j*ds
for i=0,2*lp do for j=0,2*lp do y(i,j)=-lp*ds+j*ds
;%Here take the transpose of x and y to make it the same 
;%as the orig code...
;%[x,y] = meshgrid( [-lp:lp]*ds, [-lp:lp]*ds );
;%problem with syntax atan2 
;% atan2(y,x) is replaced by atan cross language...
lam = atan(y,x);
;%problem with syntax x.^2
;% note here: .^ is the same as ^...
;%r = sqrt(x.^2 + y.^2); r(find(r==0)) = nan;
r = sqrt(x^2 + y^2) & zz=where(r eq 0) &  r(zz) = !VALUES.F_NAN ;

xkm = x*1e-3 & ykm = y*1e-3 & xx = xkm(1,*) & yy = ykm(*,1);
;%cx = rm*1e-3*sin(0:0.01:6.28);  % Circle for rmw plots.
;%cy = rm*1e-3*cos(0:0.01:6.28);
cx=fltarr(629) & cy=fltarr(629)
for i=0,628 do cx(i) = rm*1e-3*sin(0+i*0.01);  % Circle for rmw plots.
for i=0,628 do cy(i) = rm*1e-3*cos(0+i*0.01);

;% Define parametric gradient wind (V) and vorticity (Z) profiles
;% using Holland (1980) bogus with core modified to quadratic.
;% rmrb = (rm./r).^b;
;% syntax problem here, just delete the .
rmrb = (rm/r)^b;
;%V = sqrt( b*dp/rho * exp(-rmrb) .* rmrb + (0.5*f*r).^2 ) - 0.5*f*r;
;% syntax problem here, just delete the .
V = sqrt( b*dp/rho * exp(-rmrb) * rmrb + (0.5*f*r)^2 ) - 0.5*f*r;
;%Z = -f + sqrt( 4*b*dp/rho * exp(-rmrb) .* rmrb + (f*r).^2 ) ...
;%       .* ( b*dp/rho * rmrb .* (2 + b*(rmrb - 1)) .* exp(-rmrb) + (f*r).^2 )...
;%       ./ ( r .* ( 4*b*dp/rho * exp(-rmrb) .* rmrb + (f*r).^2 ) );
;% syntax problem here, just delete the . and replace ... with &$
Z = -f + sqrt( 4*b*dp/rho * exp(-rmrb) * rmrb + (f*r)^2 ) $
       * ( b*dp/rho * rmrb * (2 + b*(rmrb - 1)) * exp(-rmrb) + (f*r)^2 ) $
       / ( r * ( 4*b*dp/rho * exp(-rmrb) * rmrb + (f*r)^2 ) );
; 0 for % Quadratic core and cubic fit for 1
if (0) then begin &$
   Vm = max(V(*)) &$
;   %rs = r( find( V==Vm ) ) & rs = rs(1);
;   %syntax error
   ivvm= where(v eq vm) & print,size(ivvm) & rs=r(ivvm) & rs=rs(1) &$
   print,'*******' &$
   rmrsb = (rm/rs)^b &$
   Vs = sqrt( b*dp/rho * exp(-rmrsb) * rmrsb + (0.5*f*rs)^2 ) - 0.5*f*rs &$
   icore= where(r lt rs) &$
   V(icore) = Vs * (r(icore)/rs) * (2 - (r(icore)/rs))  &$
   Z(icore) = Vs/rs * (4 - 3*r(icore)/rs) &$
endif else begin  &$
   E = exp(1) &$
   Vm = sqrt( b*dp/(rho*E) + (0.5*f*rm)^2 ) - 0.5*f*rm  &$
   dVm = -f/2 + ( E*(f^2)*rm*sqrt((4*b*dp/rho)/E + (f*rm)^2) )/ $
                ( 2*(4*b*dp/rho + E*(f*rm)^2) ) &$
   d2Vm = ( b*dp*(-4*b^3*dp/rho - (-2 + b^2)*E*(f*rm)^2) ) / $
          ( E*rho*sqrt((4*b*dp)/(E*rho) + (f*rm)^2) * $
            (4*b*dp*rm^2/rho + E*(f*rm^2)^2) )  &$
   aa = ( d2Vm/2 - ( dVm - Vm/rm )/rm ) / rm &$
   bb = ( d2Vm - 6*aa*rm ) / 2    &$
   cc = dVm - 3*aa*rm^2 - 2*bb*rm  &$
   icore= where(r lt rm) &$
   print,'***else****' &$
   V(icore) = r(icore) * ( r(icore) * ( r(icore)*aa + bb ) + cc ) &$
   Z(icore) = r(icore) * ( r(icore) * 4*aa + 3*bb ) + 2*cc &$
   print,'***else****' &$
   pm = pe - dp*(1 - exp(-1)) &$
   p=fltarr(61,61) &$
   p(icore) = pm + ( r(icore)^6 - rm^6 ) * (aa^2)/6 $
                 + ( r(icore)^5 - rm^5 ) * (2*aa*bb)/5  $
                 + ( r(icore)^4 - rm^4 ) * (aa*(2*cc+f)+bb^2)/4  $
                 + ( r(icore)^3 - rm^3 ) * (bb*(2*cc+f))/3  $
                 + ( r(icore)^2 - rm^2 ) * (cc*(cc+f))/2  &$
endelse

Vx = -V*y/r;  % Cartesian winds
Vy =  V*x/r;

I2 = (f + 2*V/r)*(f + Z);  % Inertial stability squared

K = 50;    % Diffusivity
C = 0.002; % Drag coefficient

;% Calculate alpha, beta, gamma, chi, eta and psi in Kepert (2001). 
;% The III's are to get the solution in the case where V/r > I.
al = (2 * V / r + f) / (2*K);
be = (f + Z) / (2*K);
gam = V / (2*K*r);
;III = find(gam > sqrt(al*be));
III = where(gam gt sqrt(al*be));
print,' ***III***',III

;%fixup = find(isnan(al) | isnan(be) | isnan(gam));
fixup = where ((al eq !VALUES.F_NAN) or (be eq !VALUES.F_NAN) or (gam eq !VALUES.F_NAN));
;
print,'**chi***'
chi = (C/K)*V / sqrt(sqrt(al*be)      ) & if (fixup ge 0.) then chi( fixup ) = !VALUES.F_NAN;
;eta = (C/K)*V / sqrt(sqrt(al*be) + gam) & eta( fixup ) = !VALUES.F_NAN;
;psi = (C/K)*V / sqrt( abs( sqrt(al*be) - gam) )  &  psi( fixup ) = !VALUES.F_NAN;
;chi = (C/K)*V / sqrt(sqrt(al*be)      ) ;
eta = (C/K)*V / sqrt(sqrt(al*be) + gam) ;
psi = (C/K)*V / sqrt( abs( sqrt(al*be) - gam) )  ;
albe = sqrt(al/be);

;% Calculate A_k's ... p and m refer to k = +1 and -1. i is sqrt(-1).
;A0 =  -chi*V*(1 + i*(1 + chi)) / ( 2*chi^2 + 3*chi + 2 ) & A0(fixup) = !VALUES.F_NAN;
;A0=complexarr(61,61)
;A0 =  -chi*V*(1 + i*(1 + chi)) / ( 2*chi^2 + 3*chi + 2 ) ;
A0 =  -chi*V*(1 + complex(0,1)*(1 + chi)) / ( 2*chi^2 + 3*chi + 2 ) ;
;u0s = albe * real(A0);   % Symmetric surface wind component
u0s = albe * float(A0);   % Symmetric surface wind component
;v0s =         imag(A0);
v0s =         imaginary(A0);
Am = -( (1 + (1+complex(0,1))*eta)/albe $
      + (2 + (1+complex(0,1))*eta) )*psi*Ut $
   / ( (2 + 2*complex(0,1))*(1 + eta*psi) + 3*psi + 3*complex(0,1)*eta ); 
AmIII = -( (1 + (1+complex(0,1))*eta)/albe $
           + (2 + (1+complex(0,1))*eta) )*psi*Ut $
       / ( 2 - 2*complex(0,1) + 3*(psi + eta) + (2 + 2*complex(0,1))*eta*psi );
;Am(III) = AmIII(III);
;Am(fixup) = !VALUES.F_NAN;
;ums = albe * real( Am * exp(-i*lam) );  % First asymmetric surface component
ums = albe * float( Am * exp(-complex(0,1)*lam) );  % First asymmetric surface component
;vms =         imag( Am * exp(-complex(0,1)*lam) );
vms =         imaginary( Am * exp(-complex(0,1)*lam) );
Ap = -( (1 + (1+complex(0,1))*psi)/albe $
      - (2 + (1+complex(0,1))*psi) )*eta*Ut $
   / ( (2 + 2*complex(0,1))*(1 + eta*psi) + 3*eta + 3*complex(0,1)*psi ); 
ApIII = -(  (1 + (1-complex(0,1))*psi)/albe $
           - (2 + (1-complex(0,1))*psi) )*eta*Ut $
       / ( 2 + 2*complex(0,1) + 3*(eta + psi) + (2 - 2*complex(0,1))*eta*psi );
;Ap(III) = ApIII(III);
;Ap(fixup) = !VALUES.F_NAN;
;ups = albe * real( Ap * exp(i*lam) ); % Second asymmetric surface component
ups = albe * float( Ap * exp(complex(0,1)*lam) ); % Second asymmetric surface component
;vps =         imag( Ap * exp(complex(0,1)*lam) );
vps =         imaginary( Ap * exp(complex(0,1)*lam) );

;% Total surface wind in (moving coordinate system)
us =     u0s + ups + ums;
vs = V + v0s + vps + vms;

;% Total surface wind in stationary coordinate system (f for fixed)
usf = us + Ut*cos(lam);
vsf = vs - Ut*sin(lam);
Uf =   + Ut*cos(lam);
Vf = V - Ut*sin(lam);
 
;***************************************************************
;%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;% +++++++++++++++++++++3 d part now ++++++++++++++++++++++++++++++++++++++++++
;%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;% Coefficients p_k for k = 0, 1, -1.
p0 = -(1 + complex(0,1)) * (al * be)^(1/4);
pp = -(1 + complex(0,1)) * sqrt( sqrt(al * be) + gam );
pm = -(1 + complex(0,1)) * sqrt( abs( sqrt(al * be) - gam ) );
if (III ge 0.0) then pm(III) = -complex(0,1) * pm(III);

;% Set up a 3-d grid and calculate winds and horizontal divergence,
;% then vertical velocity.
;% nz=5 ; z=[1:nz]*10
nz = 5 &  z=intarr(nz) 
for i=0,nz-1 do z(i) = i*10;

;%[ny,nx] = size(x);
nx=2*lp+1 & ny=2*lp+1
;%nz = max(size(z));
;u = zeros(nz,ny,nx);
u=replicate(0.0,nz,ny,nx);
;v = zeros(nz,ny,nx);
v=replicate(0.0,nz,ny,nx);
;ux = zeros(nz,ny,nx);  % x for cartesian wind
ux=replicate(0.0,nz,ny,nx);
;vx = zeros(nz,ny,nx);
vx=replicate(0.0,nz,ny,nx);
;w = zeros(nz,ny,nx);
w=replicate(0.0,nz,ny,nx);
;hdiv = zeros(nz,ny,nx);
hdiv=replicate(0.0,nz,ny,nx);
;uxa = zeros(nz,ny,nx);  % Asymmetric parts have trailing a
uxa=replicate(0.0,nz,ny,nx);
;vxa = zeros(nz,ny,nx);
vxa=replicate(0.0,nz,ny,nx);
;wa = zeros(nz,ny,nx);
wa=replicate(0.0,nz,ny,nx);
;hdiva = zeros(nz,ny,nx);
hdiva=replicate(0.0,nz,ny,nx);
;
ua=fltarr(nz,ny,nx)
va=fltarr(nz,ny,nx)

;%for kk = (1:nz),
for kk = 0,nz-1 do begin  &$
;   % These w's are really omega's!
   wm = Am * exp(z(kk)*pm - complex(0,1)*lam) &$; wm(fixup) = !VALUES.F_NAN &$
   w0 = A0 * exp(z(kk)*p0        )  &$;  w0(fixup) = !VALUES.F_NAN &$
   wp = Ap * exp(z(kk)*pp + complex(0,1)*lam) &$; wp(fixup) = !VALUES.F_NAN &$

   u(kk,*,*) =     albe*float(wm + w0 + wp) &$
   v(kk,*,*) = V +       imaginary(wm + w0 + wp) &$
   ua(kk,*,*) = albe*float(wm + wp) &$
   va(kk,*,*) =       imaginary(wm + wp) &$

;%   ux(kk,*,*) = ( squeeze(u(kk,*,*))*x - squeeze(v(kk,*,*))*y ) / r;
;%   vx(kk,*,*) = ( squeeze(v(kk,*,*))*x + squeeze(u(kk,*,*))*y ) / r;
;%   hdiv(kk,*,*) = div(squeeze(ux(kk,*,*)), squeeze(vx(kk,*,*)), ds);
;%   uxa(kk,*,*) = ( squeeze(ua(kk,*,*))*x - squeeze(va(kk,*,*))*y ) / r;
;%   vxa(kk,*,*) = ( squeeze(va(kk,*,*))*x + squeeze(ua(kk,*,*))*y ) / r;
;%   hdiva(kk,*,*) = div(squeeze(uxa(kk,*,*)), squeeze(vxa(kk,*,*)), ds);
   ux(kk,*,*) = ( reform(u(kk,*,*))*x - reform(v(kk,*,*))*y ) / r  &$
   vx(kk,*,*) = ( reform(v(kk,*,*))*x + reform(u(kk,*,*))*y ) / r  &$
;   hdiv(kk,*,*) = div(reform(ux(kk,*,*)), reform(vx(kk,*,*)), ds) &$
   uxa(kk,*,*) = ( reform(ua(kk,*,*))*x - reform(va(kk,*,*))*y ) / r  &$
   vxa(kk,*,*) = ( reform(va(kk,*,*))*x + reform(ua(kk,*,*))*y ) / r  &$
;   hdiva(kk,*,*) = div(reform(uxa(kk,*,*)), reform(vxa(kk,*,*)), ds)  &$
endfor

;% Integrate the hydrostatic equation - these w's are vertical velocity.
;w (1,*,*) = -hdiv (1,*,*) * 10.0;
;wa(1,*,*) = -hdiva(1,*,*) * 10.0;
;for (kk = 2:nz),
;for kk = 2,nz do begin &$
;  w (kk,*,*) = w (kk-1,*,*) - hdiv (kk,*,*) * (z(kk) - z(kk-1)) &$
;  wa(kk,*,*) = wa(kk-1,*,*) - hdiva(kk,*,*) * (z(kk) - z(kk-1)) &$
;endfor
print,'****y***'

;%ucon = -20:2:10;
ucon=fltarr(16) & for i=0,15 do ucon(i)=-20+i*2
;%vcon = 0:5:40;
vcon=fltarr(9) & for i=0,8 do vcon(i)=i*5
;%wcon = -0.2:0.02:0.5;
wcon=fltarr(36) & for i=0,35 do wcon(i)=-0.2+i*0.02
;%
;%figure(3); clf;
;%
;%figure(4); clf;
;%
;%figure(5); clf;
;%
;%figure(6); clf;
;%
;%
;%figure(7); clf;
;%
;%
;%figure(8); clf;

;%norm(1,11)
;%
;%
;%
print,'****y***'
;%[cs,h] = contourf(xkm,ykm, swf2); set(h,'LineStyle','none');
;%[cs,h] = contour(xkm,ykm, swf2); clabel(cs,h);
;%xlabel('Storm-relative asymetric w WE section');
;%subplot(2,2,4); cla; 
;%contourf(xx,z,squeeze(wa(:,:,lp+1)),wcon,'k'); hold on;
;%[cs,h] = contour(xx,z,squeeze(wa(:,:,lp+1)),[0 0],'k'); set(h,'LineWidth',2);
;%xlabel('Storm-relative asymetric w SN section');

;[vmax,imax] = max(v,[],1); vmax = shiftdim(vmax); imax = shiftdim(imax);
;zmax = z(imax);
;fac1 = vmax/V;
;fac2 = ( vmax - Ut*sin(lam) ) / ( V - Ut*sin(lam) );

;***************************************************************
save,u,v,filename='uv3d.idl'
exit
;ciao
